// hai hai

freeslot(
"sfx_ptbhur", //boss punch
"sfx_ptbvul", //boss vulnerable
"sfx_ptjump", //pizza tower jump, pepperman
"sfx_ptslam", //groundslam land, chisel land, pepperman slam
"sfx_ptbrek", //brick break, chisel hurt
"sfx_ptenkl", //enemy kill, pepperman floor hit hurt
"sfx_ptbscr" //peppino SCREAM
)

//substitutes
freeslot(
"sfx_ptpmch", //pepperman charge
"sfx_ptpmct", //pepperman charge turn
"sfx_ptpmcw", //pepperman charge wall hit
"sfx_ptpmgs", //pepperman groundpound start
"sfx_ptpmwb", //vuln and bounce wall bounce
"sfx_ptpmhr", //hurt gasp
"sfx_ptpmsa", //statue appear
"sfx_ptpmks" //knight slide
)

sfxinfo[sfx_ptpmsa] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND
}

sfxinfo[sfx_ptbhur] = {
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND
}

sfxinfo[sfx_ptenkl] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND
}

local function SpawnBangEffect(mo)
	local effect = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT)
	effect.state = S_PIZZATOWERBOSS_BANGEFFECT
end

local function SpawnJumpDustEffect(mo)
	local effect = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT)
	effect.state = S_PIZZATOWERBOSS_JUMPDUST
end

local function SpawnLandDustEffect(mo)
	local effect = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT)
	effect.state = S_PIZZATOWERBOSS_LANDDUST
end

freeslot(
"MT_BOSS_PEPPERMAN",
"MT_PEPPERMAN_SPAWNSIGHT",
"MT_PEPPERMAN_HURTBOX",
"MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT",
"S_PIZZATOWERBOSS_GROUNDPOUNDEFFECT",
"S_PIZZATOWERBOSS_BANGEFFECT",
"S_PIZZATOWERBOSS_JUMPDUST",
"S_PIZZATOWERBOSS_LANDDUST",
"SPR_PRBG", //bang effect
"SPR_PRJD", //jump dust
"SPR_PRGP", //ground pound effect
"SPR_PRAU", //aura effect
"SPR_PRLD", //land dust
"MT_PIZZATOWERBOSS_AFTERIMAGE",
"S_PEPPERMAN_SPAWN",
"S_PEPPERMAN_PREINTRO",
"S_PEPPERMAN_INTRO1",
"S_PEPPERMAN_INTRO2",
"S_PEPPERMAN_INTRO2_LOOP",
"S_PEPPERMAN_INTRO3",
"S_PEPPERMAN_INTRO3_LOOP",
"S_PEPPERMAN_INTRO_END",
"SPR_PRI1",
"SPR_PRI2",
"SPR_PRI3",
"SPR_PRI4",
"SPR_PRI5",
"S_PEPPERMAN_IDLE",
"S_PEPPERMAN_CHOOSEATTACK",
"S_PEPPERMAN_CHARGEWINDUP",
"S_PEPPERMAN_CHARGE",
"S_PEPPERMAN_WALLBONK",
"S_PEPPERMAN_WALLBONKLOOP",
"S_PEPPERMAN_HURTTHROWN",
"S_PEPPERMAN_HURT",
"S_PEPPERMAN_HURTCHECK", //0 frame state to make sure pepperman gets hurt if he doesn't hit a wall somehow
"S_PEPPERMAN_CHARGETURN",
"S_PEPPERMAN_CHARGETURNLOOP",
"S_PEPPERMAN_JUMP",
"S_PEPPERMAN_JUMPLOOP",
"S_PEPPERMAN_GROUNDSLAMSTART",
"S_PEPPERMAN_GROUNDSLAM",
"S_PEPPERMAN_GROUNDSLAMLAND",
"S_PEPPERMAN_GROUNDSLAMLANDTOBOUNCE",
"S_PEPPERMAN_GROUNDSLAMGETUP",
"S_PEPPERMAN_BOUNCE",
"S_PEPPERMAN_SOURIDLE",
"S_PEPPERMAN_CONTEMPLATE",
"S_PEPPERMAN_MINI_SHRINK",
"S_PEPPERMAN_MINI_IDLE",
"S_PEPPERMAN_MINI_RUN",
"S_PEPPERMAN_MINI_JUMP",
"S_PEPPERMAN_MINI_FALL",
"S_PEPPERMAN_MINI_GROW",
"SPR_PRMS", //pepperman shrink
"SPR_PRMI", //mini pepperman idle
"SPR_PRMR", //mini pepperman run
"SPR_PRMJ", //mini pepperman  jump
"SPR_PRMF", //mini pepperman fall
"SPR_PRMG", //mini pepperman grow to normal
"SPR_PRID", //idle
"SPR_PRCW", //charge windup
"SPR_PRCH", //charge
"SPR_PRCT", //charge turn
"SPR_PRCL", //charge turn loop
"SPR_PRWH", //wall hit
"SPR_PRWL", //wall hit stun loops
"SPR_PRHT", //hit and being thrown
"SPR_PRHA", //bouncing around after being thrown
"SPR_PRJM", //jump to groundslam
"SPR_PRJF", //jump after anim loop
"SPR_PRSS", //slam animation start
"SPR_PRSF", //slam down loop
"SPR_PRSL", //slam land
"SPR_PRRL", //bounce roll
"SPR_PRCN", //contemplate art
"SPR_PRSI", //sour idle
"sfx_ptpmsn", //pepperman snicker
"sfx_ptpmlg", //pepperman second phase laugh
"sfx_ptpmsh", //pepperman shrink
"sfx_ptpmsc" //pepperman scared
)

freeslot(
"SPR_PTFS",
"MT_PIZZATOWERBOSS_FINISHERSHINE",
"S_PIZZATOWERBOSS_FINISHERSHINE",
"S_PIZZATOWERBOSS_FINISHERDELAY",
"S_PIZZATOWERBOSS_FINISHERFLY",
"sfx_ptbfin", //blackout punch noise
"sfx_ptbspk" //blackout punch spark
)

mobjinfo[MT_PIZZATOWERBOSS_FINISHERSHINE] = {
	spawnstate = S_PIZZATOWERBOSS_FINISHERSHINE,
	flags = MF_NOCLIP|MF_NOGRAVITY,
	dispoffset = 1
}

states[S_PIZZATOWERBOSS_FINISHERSHINE] = {SPR_PTFS, FF_ANIMATE|FF_FULLBRIGHT,  C*2, nil, 2, 2, nil}

local function PTBRestoreLight(mo)
	P_FadeLight(0, 255, 0, true)
	P_FadeLight(3, 255, 0, true)
	S_SetInternalMusicVolume(100)
	
	if (mo)
	and (mo.valid)
		mo.flags = $1 & ~MF_NOGRAVITY
		mo.state = mo.mystate
		//apparently an issue so double check
		if not (mo.valid) then
			return
		end
		mo.sprite = mo.mysprite
		mo.frame = mo.myframe
	end
end
states[S_PIZZATOWERBOSS_FINISHERDELAY] = {SPR_PLAY, SPR2_PAIN,  60, nil, K, 2, S_PIZZATOWERBOSS_FINISHERFLY}
states[S_PIZZATOWERBOSS_FINISHERFLY] = {SPR_PLAY, SPR2_PAIN,  -1, PTBRestoreLight, 0, 0, S_PIZZATOWERBOSS_FINISHERFLY}

//see if there's a wall closer to the right than left
//and turn left instead to hopefully give a better view
local function PTBFinisherLeftRightCheck(mo)
	local sight = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_PEPPERMAN_SPAWNSIGHT)
	sight.fuse = 2
	sight.flags = MF_NOGRAVITY|MF_NOCLIPTHING
	sight.angle = mo.angle + ANGLE_90
	P_InstaThrust(sight, sight.angle, 32*FRACUNIT)
	local sightcount = 0
	while (sightcount < 128)
		P_RailThinker(sight)
		sightcount = $1 + 1
	end
	local rightDist = R_PointToDist2(mo.x, mo.y, sight.x, sight.y)
	P_RemoveMobj(sight)
	
	sight = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_PEPPERMAN_SPAWNSIGHT)
	sight.fuse = 2
	sight.flags = MF_NOGRAVITY|MF_NOCLIPTHING
	sight.angle = mo.angle - ANGLE_90
	P_InstaThrust(sight, sight.angle, 32*FRACUNIT)
	sightcount = 0
	while (sightcount < 128)
		P_RailThinker(sight)
		sightcount = $1 + 1
	end
	local leftDist = R_PointToDist2(mo.x, mo.y, sight.x, sight.y)
	P_RemoveMobj(sight)
	
	if (rightDist <= leftDist) then
		return 1
	else
		return -1
	end
end

local function PTBFinisherTrigger(mo, inf, src)
	local startInf = inf
	if not (inf)
	or not (inf.player)
		if (src)
		and (src.player)
			inf = src
		else
			return
		end
	end
	
	inf.player.powers[pw_nocontrol] = 2*TICRATE
	
	//special exception for knuckles glide because it looks lame
	if (inf.player.charability == CA_GLIDEANDCLIMB)
	and (inf.state == S_PLAY_FALL)
	and (inf.player.pflags & PF_THOKKED)
		inf.sprite2 = SPR2_GLID
		inf.frame = A
	end
	
	inf.momx = 0
	inf.momy = 0
	inf.momz = 0
	
	mo.flags = $1|MF_NOGRAVITY
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
	
	P_SetOrigin(mo, mo.x, mo.y, mo.z + FRACUNIT)
	
	//player is hitting with melee
	//teleport them a tiny amount above the air to fix dumb sprite overwrites
	if (inf == startInf)
	and (P_IsObjectOnGround(mo))
		P_SetOrigin(inf, inf.x, inf.y, inf.z + FRACUNIT)
	end
	inf.ptbtarg = mo
	inf.angle = R_PointToAngle2(inf.x, inf.y, mo.x, mo.y)
	
	S_SetInternalMusicVolume(25)
	S_StartSound(inf, sfx_ptbfin)
	
	mo.savecamerascale = inf.player.camerascale
	mo.savedang = inf.angle
	mo.keepframe = inf.frame
	mo.savestate = inf.state
	mo.savesprite2 = inf.sprite2
	mo.savesprite = inf.sprite
	mo.savetics = inf.tics
	mo.saveframe = inf.frame
	
	mo.state = S_PEPPERMAN_HURTTHROWN
	mo.sprite = SPR_PRHT
	mo.frame = A
	mo.mystate = mo.state
	mo.mysprite = mo.sprite
	mo.myframe = mo.frame
	
	inf.player.camerascale = ($1/3)*2
	mo.angle = inf.angle + ANGLE_180
	mo.state = S_PIZZATOWERBOSS_FINISHERDELAY
	inf.flags = $1|MF_NOCLIPTHING
	mo.sprite = mo.mysprite
	mo.frame = mo.myframe
	mo.colorized = false
	mo.color = SKINCOLOR_NONE
	
	inf.player.resetptbcamera = true
	inf.player.resetptbcameracheck = mo
	
	mo.cameramult = PTBFinisherLeftRightCheck(inf)
	
	mo.frame = $1|FF_FULLBRIGHT
	inf.frame = $1|FF_FULLBRIGHT
	P_FadeLight(0, 160, 10, true)
	P_FadeLight(3, 160, 10, true)
	return true
end


local function SpawnFinisherShine(player, targ)
	local angle = player.drawangle
	local mo = player.mo
	local radius = 15*FRACUNIT
	local x = player.mo.x + FixedMul(cos(angle), radius)
	local y = player.mo.y + FixedMul(sin(angle), radius)
	
	local shine = P_SpawnMobj(x, y, mo.z + (mo.height/2), MT_PIZZATOWERBOSS_FINISHERSHINE)
	shine.state = S_PIZZATOWERBOSS_FINISHERSHINE
	
	//ding sound goes here
	S_StartSound(targ, sfx_ptbspk)
end

local function PTBFinisherPlayer(player)
	
	if not (player.mo)
	or not (player.mo.valid) then
		return
	end
	
	//camera zoom reset for weird cases
	if (player.resetptbcamera)
	and (player.resetptbcameracheck)
	and not (player.resetptbcameracheck.valid)
		player.camerascale = skins[player.skin].camerascale
		player.resetptbcamera = nil
		player.resetptbcameracheck = nil
	end
	
	local mo = player.mo

	if (mo.ptbtarg) then
		if not (mo.ptbtarg.valid) then
			mo.ptbtarg = nil
			return
		end
		local targ = mo.ptbtarg
		
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0


		mo.sprite = targ.savesprite
		mo.sprite2 = targ.savesprite2
		mo.frame = targ.saveframe
		mo.frame = $1 & ~FF_ANIMATE //stops flickering for some animations
		//dumb stupid dumb dumb stupid rolling stuff that doesn't want to play nice
		if (mo.sprite2 == SPR2_STND) then
			mo.sprite2 = SPR2_ROLL
		end
		mo.frame = $1|FF_FULLBRIGHT
		mo.tics = 5
		
		targ.momx = 0
		targ.momy = 0
		targ.momz = 0
		
		mo.angle = targ.savedang
		mo.angle = $1 + ((ANG1 + (ANG1/2)) * targ.cameramult)
		targ.savedang = mo.angle
		
		if (targ.tics == 14) then
			SpawnFinisherShine(player, targ)
		end
		
		if not (targ.state == S_PIZZATOWERBOSS_FINISHERDELAY)
			S_StartSound(targ, sfx_ptbhur)
			player.resetptbcamera = nil
			player.resetptbcameracheck = nil
			targ.momz = 8*FRACUNIT
			P_InstaThrust(targ, targ.angle - ANGLE_180, 50*FRACUNIT)
			
			mo.state = targ.savestate
			mo.sprite = targ.savesprite
			mo.sprite2 = targ.savesprite2
			mo.frame = targ.saveframe
			mo.tics = targ.savetics
			
			if (P_IsObjectOnGround(mo)) then
				P_SetOrigin(mo, mo.x, mo.y, mo.z + FRACUNIT)
			end
			
			P_InstaThrust(mo, targ.angle, 16*FRACUNIT)		
			mo.momz = 7*FRACUNIT
			player.camerascale = targ.savecamerascale

			targ.target = mo
			mo.ptbtarg = nil
			
			mo.angle = targ.angle - ANGLE_180
			
			targ.state = S_PEPPERMAN_HURTTHROWN
			mo.flags = $1 & ~MF_NOCLIPTHING
		end
	end
end
addHook("PlayerThink", PTBFinisherPlayer)





local function PeppermanDestroyStatue(mo)
	//delete statue
	if (mo.statue)
	and (mo.statue.valid)
		P_KillMobj(mo.statue)
	end
	mo.statue = nil
end


//choose closest player to attack to spice up multiplayer
local function ClosestLookForPlayer(mo, dist, alwaysallaround, settracer)
	local target = nil
	local targetdistance = -1

	for player in players.iterate() do
		if not (player.mo)
		or not (player.mo.valid)
		or not (player.mo.health)
			continue
		end
		
		local mydist = R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y)
		//within distance limit
		//and can see them
		if (dist)
		and (mydist > dist)
		or not (P_CheckSight(mo, player.mo))
			continue
		end
		
		//no other player set yet
		if (targetdistance < 0) then
			target = player.mo
			targetdistance = mydist
		else
			//closer target, choose instead
			if (mydist < targetdistance) then
				target = player.mo
				targetdistance = mydist
			end
		end
	end

	if (settracer) then
		mo.tracer = target
	else
		mo.target = target
	end
end

local function PeppermanScreenShake(mo)
	P_StartQuake(7*FRACUNIT, 11)
end

local function MiniPeppermanRunAway(mo)
	if (mo.target)
	and (R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < 312*FRACUNIT) then
		mo.angle = R_PointToAngle2(mo.target.x, mo.target.y, mo.x, mo.y)
		P_InstaThrust(mo, mo.angle, 22*mo.scale)
		
		if not (mo.state == S_PEPPERMAN_MINI_RUN) then
			mo.state = S_PEPPERMAN_MINI_RUN
		end
	else
		mo.target = nil
		if (mo.state == S_PEPPERMAN_MINI_RUN) then
			mo.state = S_PEPPERMAN_MINI_IDLE
			mo.momx = 0
			mo.momy = 0
		end
	end
end

local function MiniPeppermanThinker(mo)
	if not (mo.shrinktime) then
		mo.minipepperman = false
		mo.state = S_PEPPERMAN_MINI_GROW
		S_SetInternalMusicVolume(100)
		return
	end
	
	local oldtarget = mo.target
	ClosestLookForPlayer(mo, 128*FRACUNIT)
	
	if not (mo.target)
		mo.target = oldtarget
	end
	
	if (mo.state == S_PEPPERMAN_MINI_JUMP)
	or (mo.state == S_PEPPERMAN_MINI_FALL) then
		if (P_IsObjectOnGround(mo)) then
			mo.state = S_PEPPERMAN_MINI_IDLE
			MiniPeppermanRunAway(mo)
		end
	else
		MiniPeppermanRunAway(mo)
	end

	mo.shrinktime = $1 - 1
end

local function PeppermanShrink(mo)
	mo.shrinktime = 15*TICRATE
	mo.minipepperman = true
end

states[S_PEPPERMAN_MINI_SHRINK] = {SPR_PRMS, FF_ANIMATE,  L*2, nil, K, 2, S_PEPPERMAN_MINI_IDLE}
states[S_PEPPERMAN_MINI_IDLE] = {SPR_PRMI, FF_ANIMATE, -1, nil, L, 2, S_PEPPERMAN_MINI_IDLE}
states[S_PEPPERMAN_MINI_RUN] = {SPR_PRMR, FF_ANIMATE,  -1, nil, G, 2, S_PEPPERMAN_MINI_IDLE}
states[S_PEPPERMAN_MINI_JUMP] = {SPR_PRMJ, FF_ANIMATE, N*2, nil, M, 2, S_PEPPERMAN_MINI_FALL}
states[S_PEPPERMAN_MINI_FALL] = {SPR_PRMF, FF_ANIMATE,  -1, nil, C, 2, S_PEPPERMAN_MINI_FALL}
states[S_PEPPERMAN_MINI_GROW] = {SPR_PRMG, FF_ANIMATE,  M*2, nil, L, 2, S_PEPPERMAN_IDLE}

//extra stuff
freeslot(
"MT_PEPPERMAN_CHISELSTATUE",
"MT_PEPPERMAN_FALLINGSTATUE",
"MT_PEPPERMAN_ARTDUDE",
"MT_PEPPERMAN_PAINTING",
"MT_PEPPERMAN_KNIGHTSTATUE",
"MT_PEPPERMAN_CHISELSTATUESPAWNPOINT",
"MT_PEPPERMAN_MARBLEDEBRIS",
"S_PEPPERMAN_CHISELSTATUE",
"S_PEPPERMAN_FALLINGSTATUE",
"S_PEPPERMAN_ARTDUDE",
"S_PEPPERMAN_PAINTING",
"S_PEPPERMAN_KNIGHTSTATUE",
"S_PEPPERMAN_MARBLEDEBRIS",
"SPR_PRCS",
"SPR_PRFS",
"SPR_PRAD",
"SPR_PRPT",
"SPR_PRKS",
"SPR_PRMD",
"sfx_ptpmad"
)

local function PTBFaceTowards(mo, faceto)
	local faceMe = R_PointToAngle2(mo.x, mo.y, faceto.x, faceto.y)
	if not (mo.angle == faceMe) then
		local angleFace = AngleFixed(faceMe)
		local angleFacing = AngleFixed(mo.angle)
	
		if (abs(angleFacing - angleFace) > (FRACUNIT*2)) then
			local dir = 1
			
			if (angleFacing < angleFace)
				if not (abs(angleFacing - angleFace) < 180*FRACUNIT) then
					dir = -1
				end
			elseif (abs(angleFacing - angleFace) < 180*FRACUNIT)
				dir = -1
			end
			
			mo.angle = $1 + ((ANG1*2)*dir)
		else
			mo.angle = faceMe  
		end
	end
end

local function PeppermanLineLaugh(mo, line)
	local PEPPERMANWALLTEX = R_TextureNumForName("PEPBG")
	local PEPPERMANWALLREPLACETEX = R_TextureNumForName("PEPBGL1")

	if (line.frontside)
	and (line.frontside.midtexture == PEPPERMANWALLTEX)
		line.frontside.midtexture = PEPPERMANWALLREPLACETEX
	end
	
	if (line.backside)
	and (line.backside.midtexture == PEPPERMANWALLTEX)
		line.backside.midtexture = PEPPERMANWALLREPLACETEX
	end
end


local function PeppermanLineStopLaugh(mo, line)
	local PEPPERMANWALLTEX = R_TextureNumForName("PEPBGL1")
	local PEPPERMANWALLREPLACETEX = R_TextureNumForName("PEPBG")

	if (line.frontside)
	and (line.frontside.midtexture == PEPPERMANWALLTEX)
		line.frontside.midtexture = PEPPERMANWALLREPLACETEX
	end
	
	if (line.backside)
	and (line.backside.midtexture == PEPPERMANWALLTEX)
		line.backside.midtexture = PEPPERMANWALLREPLACETEX
	end
end

local function PeppermanDeath(mo)
	mo.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
	mo.fuse = 20*TICRATE
	mo.colorized = false //remove vuln flash
	
	P_SetObjectMomZ(mo, 9*FRACUNIT, true)
	P_InstaThrust(mo, mo.angle - ANGLE_180, 48*FRACUNIT)
	
	//level header musicpostboss instead
	//won't work, would loop
	S_ChangeMusic("PTBWIN", false, nil, 0x4000)
	
	for player in players.iterate() do
		player.exiting = 90
	end
	
	local SEARCHDIST = 4096*FRACUNIT
	searchBlockmap("lines", PeppermanLineStopLaugh, mo, mo.x - SEARCHDIST, mo.x + SEARCHDIST, mo.y - SEARCHDIST, mo.y + SEARCHDIST)
end
addHook("MobjDeath", PeppermanDeath, MT_BOSS_PEPPERMAN)

local function PeppermanTriggerSecondPhase(mo)
	local SEARCHDIST = 4096*FRACUNIT
	searchBlockmap("lines", PeppermanLineLaugh, mo, mo.x - SEARCHDIST, mo.x + SEARCHDIST, mo.y - SEARCHDIST, mo.y + SEARCHDIST)

	mo.secondphase = leveltime
	S_StartSound(nil, sfx_ptpmlg)
end

local function SpawnMarbleDebris(mo)
	local ang = mo.angle + (P_RandomRange(0, 45)*ANG1)

	for i = 1,4 do
		local debris = P_SpawnMobj(mo.x, mo.y, mo.z + ((mo.height/3)*2), MT_PEPPERMAN_MARBLEDEBRIS)
		debris.angle = ang + (ANGLE_90*i)
		
		P_SetObjectMomZ(debris, P_RandomRange(4, 8)*FRACUNIT)
		P_InstaThrust(debris, debris.angle, P_RandomRange(2, 3)*FRACUNIT)
	end
end
addHook("MobjDeath", SpawnMarbleDebris, MT_PEPPERMAN_CHISELSTATUE)
addHook("MobjDeath", SpawnMarbleDebris, MT_PEPPERMAN_CHISELSTATUE)

local function RandomMarble(mo)
	mo.frame = P_RandomRange(A, D)
	mo.rollangle = P_RandomRange(0, 359)*ANG1
	mo.fuse = 5*TICRATE
end
addHook("MobjSpawn", RandomMarble, MT_PEPPERMAN_MARBLEDEBRIS)

states[S_PEPPERMAN_MARBLEDEBRIS] = {SPR_PRMD, A, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_PEPPERMAN_MARBLEDEBRIS] = {
	spawnstate = S_PEPPERMAN_MARBLEDEBRIS,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_PIZZATOWERBOSS_AFTERIMAGE] = {
	spawnstate = S_INVISIBLE,
	flags = MF_NOCLIP|MF_NOGRAVITY,
	dispoffset = -1
}


local PTBFade = {
	FF_TRANS90,
	FF_TRANS80,
	FF_TRANS70,
	FF_TRANS60,
	FF_TRANS50,
	FF_TRANS40,
	FF_TRANS30,
	FF_TRANS20,
	FF_TRANS10,
	0
}

local function PTBAfterimageThink(mo)
	if not (mo.fuse) then
		P_RemoveMobj(mo)
		return
	else
		if not (mo.setframe) then
			if (mo.fuse < 10)
				P_RemoveMobj(mo)
				return
			else
				return
			end
		end
		mo.frame = mo.setframe|PTBFade[mo.fuse]
	end
end
addHook("MobjThinker", PTBAfterimageThink, MT_PIZZATOWERBOSS_AFTERIMAGE)

local function PTBAfterimage(mo)
	local image = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PIZZATOWERBOSS_AFTERIMAGE)
	image.sprite = mo.sprite
	image.sprite2 = mo.sprite2
	image.frame = mo.frame
	image.setframe = mo.frame
	image.color = SKINCOLOR_RED
	image.colorized = true
	image.fuse = 10
end


mobjinfo[MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT] = {
	spawnstate = S_PIZZATOWERBOSS_GROUNDPOUNDEFFECT,
	flags = MF_NOCLIP|MF_NOGRAVITY,
	dispoffset = -1
}
states[S_PIZZATOWERBOSS_GROUNDPOUNDEFFECT] = {SPR_PRGP, FF_ANIMATE, 14, nil, 6, 2, S_NULL}
states[S_PIZZATOWERBOSS_BANGEFFECT] = {SPR_PRBG, FF_ANIMATE, F, nil, E, 1, S_NULL}
states[S_PIZZATOWERBOSS_JUMPDUST] = {SPR_PRJD, FF_ANIMATE, G*2, nil, F, 2, S_NULL}
states[S_PIZZATOWERBOSS_LANDDUST] = {SPR_PRLD, FF_ANIMATE, G*2, nil, F, 2, S_NULL}

states[S_PEPPERMAN_KNIGHTSTATUE] = {SPR_PRKS, FF_ANIMATE, 10*TICRATE, nil, 1, 4, S_NULL}
states[S_PEPPERMAN_ARTDUDE] = {SPR_PRAD, A, 10*TICRATE, nil, 0, 0, S_NULL}

mobjinfo[MT_PEPPERMAN_KNIGHTSTATUE] = {
	spawnstate = S_PEPPERMAN_KNIGHTSTATUE,
	radius = 32*FRACUNIT,
	height = 80*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_PEPPERMAN_ARTDUDE] = {
	spawnhealth = 5*TICRATE,
	reactiontime = 4,
	spawnstate = S_PEPPERMAN_ARTDUDE,
	radius = 24*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

local function PeppermanObjectsWallIgnore(mo, line)
	if not (line.flags & ML_IMPASSIBLE) then
		return
	end

	if (P_PointOnLineSide(mo.x, mo.y, line)) then
		return
	end

	if not (mo.linehit)
	or (mo.linehit == line) then
		mo.linehit = line
		
		local linex,liney = P_ClosestPointOnLine(mo.x, mo.y, line)
		if not (mo.linedelay)
		and (R_PointToDist2(mo.x, mo.y, linex, liney) < 12*FRACUNIT)
			mo.linedelay = 2*TICRATE
		end
	else
		if not (mo.fuse)
			mo.fuse = 10*TICRATE
		end
	end
	return false
end
addHook("MobjLineCollide", PeppermanObjectsWallIgnore, MT_PEPPERMAN_KNIGHTSTATUE)
addHook("MobjLineCollide", PeppermanObjectsWallIgnore, MT_PEPPERMAN_ARTDUDE)

local function ArtDudeThink(mo)
	if not (leveltime % 8) then
		PTBAfterimage(mo)
	end

	if (mo.type == MT_PEPPERMAN_ARTDUDE)
		if not (mo.reactiontime) then
			mo.reactiontime = mobjinfo[mo.type].reactiontime
			mo.frame = $1 + 1
			
			if (mo.frame > -1 + (3 * (mo.statueframe + 1))) then
				mo.frame = 3 * mo.statueframe
			end
			
		else
			mo.reactiontime = $1 - 1
		end
		
		if not (S_SoundPlaying(mo, sfx_ptpmad)) then
			S_StartSoundAtVolume(mo, sfx_ptpmad, 200)
		end
	end
	
	if not (mo.linedelay)
	or (mo.linedelay == 1)		
		//teleport forwards instead to ignore walls
		local angle = mo.angle
		local radius = 8*FRACUNIT
		
		if (mo.type == MT_PEPPERMAN_KNIGHTSTATUE)
		and not (S_SoundPlaying(mo, sfx_ptpmks))
		and (mo.linedelay)
			radius = 22*FRACUNIT
			S_StartSoundAtVolume(mo, sfx_ptpmks, 180)
		end
		
		local mox = mo.x + FixedMul(cos(angle), radius)
		local moy = mo.y + FixedMul(sin(angle), radius)
		P_MoveOrigin(mo, mox, moy, mo.z)
	else
		mo.linedelay = $1 - 1
		if (mo.linedelay == 1) then
			if (mo.target)
			and (mo.target.valid) then
				R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
			end
			mo.flags = $1|MF_PAIN
		end
	end
end
addHook("MobjThinker", ArtDudeThink, MT_PEPPERMAN_ARTDUDE)
addHook("MobjThinker", ArtDudeThink, MT_PEPPERMAN_KNIGHTSTATUE)

mobjinfo[MT_PEPPERMAN_SPAWNSIGHT] = {
	spawnstate = S_INVISIBLE,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 32*TICRATE
}

local function PeppermanSightCheckSpawn(mo)
	if not (mo.spawntype) then
		return
	end
	
	local angle = mo.angle
	local radius = 128*FRACUNIT
	local mox = mo.x + FixedMul(cos(angle), radius)
	local moy = mo.y + FixedMul(sin(angle), radius)
	local obj = P_SpawnMobj(mox, moy, mo.spawnheight, mo.spawntype)
	obj.angle = mo.angle - ANGLE_180
	
	if (mo.target)
	and (mo.target.valid) then
		obj.target = mo.target
	end
	
	if (obj.type == MT_PEPPERMAN_KNIGHTSTATUE) then
		S_StartSound(obj, sfx_ptpmsa)
	end
end
addHook("MobjRemoved", PeppermanSightCheckSpawn, MT_PEPPERMAN_SPAWNSIGHT) 

local function PeppermanSpawnExtraObject(mo, type, angle, backwards)
	local sight = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_PEPPERMAN_SPAWNSIGHT)
	sight.spawntype = type
	sight.spawnheight = mo.floorz
	sight.fuse = 2
	sight.flags = MF_MISSILE|MF_NOCLIPTHING
	
	if (mo.target)
	and (mo.target.valid) then
		sight.target = mo.target
	end
	
	if (backwards)
		sight.angle = angle + ANGLE_180
	else
		sight.angle = angle
	end
	P_InstaThrust(sight, sight.angle, 32*FRACUNIT)
	local sightcount = 0
	while (sightcount < 128)
		P_RailThinker(sight)
		sightcount = $1 + 1
	end
end

local function RandomizeStatue(mo)
	mo.statueframe = P_RandomRange(0, 2)
	
	if (mo.type == MT_PEPPERMAN_ARTDUDE)
		mo.frame = (3 * mo.statueframe)
	elseif (mo.type == MT_PEPPERMAN_FALLINGSTATUE)
		mo.frame = mo.statueframe * 2
		S_StartSound(mo, sfx_ptpmsa)
	end
end
addHook("MobjSpawn", RandomizeStatue, MT_PEPPERMAN_CHISELSTATUE)
addHook("MobjSpawn", RandomizeStatue, MT_PEPPERMAN_ARTDUDE)
addHook("MobjSpawn", RandomizeStatue, MT_PEPPERMAN_FALLINGSTATUE)

states[S_PEPPERMAN_FALLINGSTATUE] = {SPR_PRFS, A, -1, nil, 0, 0, S_NULL}
mobjinfo[MT_PEPPERMAN_FALLINGSTATUE] = {
	reactiontime = 35,
	spawnstate = S_PEPPERMAN_FALLINGSTATUE,
	radius = 24*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_PAIN
}

//remove pepperman being eaten when he's given the special flag only
//a bug that confused me for a little too long
local function DontEatPepperman(mo, touch)
	if (mo.flags == MF_SPECIAL) then
		return true
	end
end
addHook("TouchSpecial", DontEatPepperman, MT_BOSS_PEPPERMAN)

local function PeppermanFallingStatueThink(mo)
	if (mo.state == S_INVISIBLE) then
		return
	end
	
	if (P_IsObjectOnGround(mo)) then
		S_StartSound(mo, sfx_ptbrek)
		SpawnMarbleDebris(mo)
		mo.flags = MF_NOCLIP
		mo.state = S_INVISIBLE
		mo.tics = 20
		return
	end
	
	mo.shadowscale = (FRACUNIT/2) + FRACUNIT
	
	if not (mo.extravalue1) then
		mo.extravalue1 = 2
		mo.frame = $1 + 1
		
		if (mo.frame > (mo.statueframe *2) + 1) then
			mo.frame = 2 * mo.statueframe
		end
	else
		mo.extravalue1 = $1 - 1
	end
	
	if (mo.reactiontime == 15)
	and (mo.spawnextra) then
		if not (mo.tracer)
			ClosestLookForPlayer(mo, 0, true, true)
		end
		
		if (mo.tracer) then
			P_SpawnMobj(mo.tracer.x, mo.tracer.y, mo.tracer.z + 512*FRACUNIT, MT_PEPPERMAN_FALLINGSTATUE)
		end
	end
	
	if (mo.reactiontime) then
		mo.reactiontime = $1 - 1
	else
		if not (leveltime % 8) then
			PTBAfterimage(mo)
		end
		mo.flags = $1 & ~MF_NOGRAVITY
	end
end
addHook("MobjThinker", PeppermanFallingStatueThink, MT_PEPPERMAN_FALLINGSTATUE)

//disable damage on touch
local function HarmlessEnemy(mo, inf)
	if (inf)
		if (inf.type == MT_BOSS_PEPPERMAN)
		or (inf.type == MT_PEPPERMAN_CHISELSTATUE)
			return false
		end
	end
end
addHook("ShouldDamage", HarmlessEnemy)

local statueSpawnPoints = {}
local function AddStatueSpawn(mo)
	table.insert(statueSpawnPoints, {x = mo.x, y = mo.y, z = mo.z})
end
addHook("MobjSpawn", AddStatueSpawn, MT_PEPPERMAN_CHISELSTATUESPAWNPOINT)

local function GiveSpawnTableCopy()
	local newTable = {}
	for pos, val in ipairs(statueSpawnPoints)
		table.insert(newTable, {x = val.x, y = val.y, z = val.z})
	end
	
	return newTable
end

local function PeppermanSpawnChiselStatue(mo)
	PeppermanDestroyStatue(mo)
	
	//dont do statues
	if (mo.minipepperman)
	or (mo.shrankbefore)
		return
	end
	
	if (mo.health < 13)
	and (mo.health > 10)
	or (mo.health < 3) then
		local spawnSpots = GiveSpawnTableCopy()
		//don't spawn in the same spot twice in a row
		//doesn't seem to work, strangely, oh well
		//update: i forgot to update the code after this to use spawnspots instead of statuespawnspots
		if (mo.laststatuenum) then
			table.remove(spawnSpots, mo.laststatuenum)
		end

		mo.laststatuenum = P_RandomRange(1, #spawnSpots)
		local point = spawnSpots[mo.laststatuenum]
		mo.statue = P_SpawnMobj(point.x, point.y, point.z + 512*FRACUNIT, MT_PEPPERMAN_CHISELSTATUE)
		
		if (mo.statue)
		and (mo.statue.valid) then
			if (mo.secondphase) then
				mo.statue.extravalue1 = 1
			end
		end
	end
end

local function PTClearTables()
	statueSpawnPoints = {}
end
addHook("MapChange", PTClearTables)

mobjinfo[MT_PEPPERMAN_CHISELSTATUESPAWNPOINT] = {
	doomednum = 2244
}

states[S_PEPPERMAN_CHISELSTATUE] = {SPR_PRCS, A, -1, nil, 0, 0, S_NULL}
mobjinfo[MT_PEPPERMAN_CHISELSTATUE] = {
	spawnstate = S_PEPPERMAN_CHISELSTATUE,
	radius = 32*FRACUNIT,
	height = 128*FRACUNIT,
	seesound = sfx_ptslam,
	painsound = sfx_ptbrek,
	deathsound = sfx_thok,
	reactiontime = 25,
	spawnhealth = 100,
	flags = MF_SHOOTABLE|MF_SPECIAL|MF_ENEMY
}

local function ChiselCollide(mo, hitmo)
	if (mo.extravalue2 > 5)
		return false
	end
end
addHook("MobjCollide", ChiselCollide, MT_PEPPERMAN_CHISELSTATUE)

local function ChiselStatue(mo, inf)
	if (mo.extravalue2)
	and (mo.extravalue2 > 5) then
		return true
	end

	if not (mo.timeshit)
		mo.timeshit = 0
	end
	
	A_Pain(mo)
	mo.timeshit = $1 + 1

	if not (mo.extravalue1) then
		mo.timeshit = $1 + 1
	end
	
	mo.extravalue2 = 15
	
	if not (mo.timeshit % 2) then
		mo.frame = (mo.timeshit/2) + (4 * mo.statueframe)
		SpawnMarbleDebris(mo)
	end
	
	if (mo.timeshit >= 6) then
		mo.flags = 0
	end
	
	if (inf)
	and (inf.valid)
		SpawnBangEffect(inf)
	
		if (inf.type == MT_PLAYER)
		and (inf.player) then
			local thrustAng = R_PointToAngle2(mo.x, mo.y, inf.x, inf.y)
			P_InstaThrust(inf, thrustAng, 16*FRACUNIT)
			P_SetObjectMomZ(inf, 5*FRACUNIT)
			inf.player.powers[pw_nocontrol] = $1 + 5
		end
	end
	
	return true
end
addHook("MobjDamage", ChiselStatue, MT_PEPPERMAN_CHISELSTATUE)

local function ChiselThink(mo)
	mo.flags2 = $1 & ~MF2_FRET
	
	if (mo.eflags & MFE_JUSTHITFLOOR) then
		mo.eflags = $1 & ~MFE_JUSTHITFLOOR
		A_PlaySeeSound(mo)
		PeppermanScreenShake(mo)
	end
	
	if not (leveltime % 2)
	and (mo.extravalue2) then
		mo.spritexoffset = P_RandomRange(-8, 8)*FRACUNIT
		mo.spriteyoffset = P_RandomRange(-8, 8)*FRACUNIT
		mo.extravalue2 = $1 - 1
	end
	
	if not (mo.extravalue2) then
		mo.spritexoffset = 0
		mo.spriteyoffset = 0
	end
end
addHook("MobjThinker", ChiselThink, MT_PEPPERMAN_CHISELSTATUE)

states[S_PEPPERMAN_PAINTING] = {SPR_PRPT, A, -1, nil, 0, 0, S_NULL}

local function PaintingCollide(mo, hitmo)
	if not (mo.fuse)
	and (P_IsObjectOnGround(hitmo))
		mo.fuse = TICRATE*3
		mo.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
		S_StartSound(mo, sfx_ptenkl)
		SpawnBangEffect(hitmo)
		P_InstaThrust(mo, R_PointToAngle2(hitmo.x, hitmo.y, mo.x, mo.y), 5*FRACUNIT)
		P_SetObjectMomZ(mo, 10*FRACUNIT)
	end
	return false
end
addHook("MobjCollide", PaintingCollide, MT_PEPPERMAN_PAINTING)

mobjinfo[MT_PEPPERMAN_PAINTING] = {
	doomednum = 2241,
	spawnstate = S_PEPPERMAN_PAINTING,
	radius = 20*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SHOOTABLE
}

mobjinfo[MT_BOSS_PEPPERMAN] = {
	doomednum = 2240,
	spawnstate = S_PEPPERMAN_SPAWN,
	painstate = S_PEPPERMAN_HURTTHROWN,
	deathstate = S_PEPPERMAN_MINI_FALL,
	activesound = sfx_bnce1,
	painsound = sfx_ptbhur,
	attacksound = sfx_ptpmsn,
	seestate = S_PEPPERMAN_IDLE,
	radius = 24*FRACUNIT,
	height = 70*FRACUNIT,
	reactiontime = 25,
	spawnhealth = 20,
	flags = 0
}

mobjinfo[MT_PEPPERMAN_HURTBOX] = {
	spawnstate = S_INVISIBLE,
	radius = 24*FRACUNIT,
	height = 50*FRACUNIT,
	flags = MF_PAIN
}

local PEPPERMANVULNTIME = 30*2

states[S_PEPPERMAN_SPAWN] = {SPR_PRID, A, 2, A_Look, 0, 0, S_PEPPERMAN_SPAWN}

local function CheckForSour(mo)
	if (mo.health < 11) then
		mo.state = S_PEPPERMAN_SOURIDLE
	end
end

states[S_PEPPERMAN_IDLE] = {SPR_PRID, FF_ANIMATE, 36, CheckForSour, 11, 2, S_PEPPERMAN_CHOOSEATTACK}
states[S_PEPPERMAN_SOURIDLE] = {SPR_PRSI, FF_ANIMATE, 36, nil, 10, 2, S_PEPPERMAN_CHOOSEATTACK}
states[S_PEPPERMAN_CHOOSEATTACK]  = {SPR_PRID, FF_ANIMATE, -1, nil, 11, 2, S_PEPPERMAN_IDLE}

states[S_PEPPERMAN_CHARGEWINDUP] = {SPR_PRCW, FF_ANIMATE, 14, nil, 6, 2, S_PEPPERMAN_CHARGE}
states[S_PEPPERMAN_CHARGE] = {SPR_PRCH, FF_ANIMATE, 2*TICRATE, A_FaceTarget, 10, 2, S_PEPPERMAN_IDLE}

local function ChargeTurnSounds(mo)
	S_StopSound(mo)
	S_StartSoundAtVolume(mo, sfx_ptpmct, 180)
end

states[S_PEPPERMAN_CHARGETURN] = {SPR_PRCT, FF_ANIMATE, 14, ChargeTurnSounds, 8, 2, S_PEPPERMAN_CHARGETURNLOOP}
states[S_PEPPERMAN_CHARGETURNLOOP] = {SPR_PRCL, FF_ANIMATE, 8, nil, 2, 2, S_PEPPERMAN_CHARGE}

states[S_PEPPERMAN_WALLBONK] = {SPR_PRWH, FF_ANIMATE, 6, nil, 2, 2, S_PEPPERMAN_WALLBONKLOOP}
states[S_PEPPERMAN_WALLBONKLOOP] = {SPR_PRWL, FF_ANIMATE, PEPPERMANVULNTIME, nil, 2, 2, S_PEPPERMAN_IDLE}

//hurt actions delayed until hitting the wall
local function PeppermanTrueHurt(mo)
	if (mo.health == 1)
	and (mo.shrinkhit)
		return
	end

	S_StartSound(mo, sfx_ptenkl)
	mo.health = $1 - 1
	PeppermanSpawnChiselStatue(mo)
	
	//gasp chance
	if not (P_RandomRange(0, 4))
		S_StartSound(mo, sfx_ptpmhr)
	end
	
	mo.lasthit = leveltime
	mo.beenhurt = true
end

local function PeppermanMakeSureHurt(mo)
	if not (mo.beenhurt) then
		PeppermanTrueHurt(mo)
	end
	mo.beenhurt = false
end

states[S_PEPPERMAN_HURTTHROWN] = {SPR_PRHT, FF_ANIMATE, 20, nil, 2, 2, S_PEPPERMAN_HURT}
states[S_PEPPERMAN_HURT] = {SPR_PRHA, FF_ANIMATE, 5*TICRATE, nil, 4, 2, S_PEPPERMAN_HURTCHECK}
states[S_PEPPERMAN_HURTCHECK] = {SPR_PRHA, FF_ANIMATE, 0, PeppermanMakeSureHurt, 0, 0, S_PEPPERMAN_IDLE}

local function PlayPeppermanJump(mo)
	S_StartSound(mo, sfx_ptjump)
	SpawnJumpDustEffect(mo)	
end

states[S_PEPPERMAN_JUMP] = {SPR_PRJM, FF_ANIMATE,  18, PlayPeppermanJump, 8, 2, S_PEPPERMAN_JUMPLOOP}
states[S_PEPPERMAN_JUMPLOOP] = {SPR_PRJF, FF_ANIMATE, 8, nil, 2, 2, S_PEPPERMAN_GROUNDSLAMSTART}


local function PlayPeppermanSlamSound(mo)
	S_StartSound(mo, sfx_ptpmgs)
end

states[S_PEPPERMAN_GROUNDSLAMSTART] = {SPR_PRSS, FF_ANIMATE, 12, PlayPeppermanSlamSound, 5, 2, S_PEPPERMAN_GROUNDSLAM}
states[S_PEPPERMAN_GROUNDSLAM] = {SPR_PRSF, FF_ANIMATE, -1, nil, 2, 2, S_PEPPERMAN_GROUNDSLAMLAND}
states[S_PEPPERMAN_GROUNDSLAMLAND] = {SPR_PRSL, A, PEPPERMANVULNTIME, nil, 2, 2, S_PEPPERMAN_GROUNDSLAMGETUP}
states[S_PEPPERMAN_GROUNDSLAMGETUP] = {SPR_PRSL, FF_ANIMATE, 14, nil, 6, 2, S_PEPPERMAN_IDLE}


local function PeppermanBounce(mo)
	A_FaceTarget(mo)
	
	mo.lastbounce = leveltime
	P_InstaThrust(mo, mo.angle, 35*FRACUNIT)
	P_SetObjectMomZ(mo, 24*FRACUNIT)
end

states[S_PEPPERMAN_GROUNDSLAMLANDTOBOUNCE] = {SPR_PRSL, FF_ANIMATE, 6, nil, 2, 2, S_PEPPERMAN_BOUNCE}
states[S_PEPPERMAN_BOUNCE] = {SPR_PRRL, FF_ANIMATE, -1, PeppermanBounce, 11, 2, S_PEPPERMAN_IDLE}

states[S_PEPPERMAN_CONTEMPLATE] = {SPR_PRCN, FF_ANIMATE, -1, A_PlayAttackSound, 5, 2, S_PEPPERMAN_IDLE}

local function PeppermanStartMusic()
	S_SetMusicPosition(0)
	S_SetInternalMusicVolume(100)
end

local function PeppermanIntroNoises(mo)
	S_StartSound(mo, sfx_ptpmlg)
	
	S_StartSound(nil, sfx_ptbscr)
end

local function PeppermanIntroPlayerReact(mo)
	for player in players.iterate() do
		player.powers[pw_nocontrol] = 1
		player.realtime = 0
		
		if (player.mo)
		and (player.mo.valid) then
			player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
			player.mo.angle = player.drawangle
			if (mo.state >= S_PEPPERMAN_INTRO3)
			and (mo.state < S_PEPPERMAN_INTRO_END)
				player.mo.sprite2 = SPR2_PAIN
				player.mo.frame = A
			else
				if not (player.mo.state == S_PLAY_STND) //supports characters with animated stands
				or not (player.mo.sprite2 == SPR2_STND)
					player.mo.state = S_PLAY_STND
				end
				player.mo.tics = states[S_PLAY_STND].tics
			end
		end
	end
end

local function PeppermanStartTimer(mo)
	mo.ptbtimermod = leveltime + (C*2)
end

local HUDIntroDelay = 5*TICRATE
states[S_PEPPERMAN_PREINTRO] = {SPR_PRI1, FF_ANIMATE,  HUDIntroDelay, nil, H, 2, S_PEPPERMAN_INTRO1}
states[S_PEPPERMAN_INTRO1] = {SPR_PRI1, FF_ANIMATE,  I*3, PeppermanStartMusic, H, 2, S_PEPPERMAN_INTRO2}
states[S_PEPPERMAN_INTRO2] = {SPR_PRI2, FF_ANIMATE, F*2, nil, E, 2, S_PEPPERMAN_INTRO2_LOOP}
states[S_PEPPERMAN_INTRO2_LOOP] = {SPR_PRI2, E,  45, nil, 0, 0, S_PEPPERMAN_INTRO3}
states[S_PEPPERMAN_INTRO3] = {SPR_PRI3, FF_ANIMATE, D*2, PeppermanIntroNoises, C, 2, S_PEPPERMAN_INTRO3_LOOP}
states[S_PEPPERMAN_INTRO3_LOOP] = {SPR_PRI4, FF_ANIMATE,  G*10, nil, F, 2, S_PEPPERMAN_INTRO_END}
states[S_PEPPERMAN_INTRO_END] = {SPR_PRI5, FF_ANIMATE,  C*2, PeppermanStartTimer, B, 2, S_PEPPERMAN_IDLE}

local function PeppermanSpawn(mo)
	mo.shadowscale = FRACUNIT
	mo.artdudetimer = 15*TICRATE
	
	if not (PTBLastMap == gamemap) then
		S_SetInternalMusicVolume(0)
		mo.state = S_PEPPERMAN_PREINTRO
	end
end
addHook("MobjSpawn", PeppermanSpawn, MT_BOSS_PEPPERMAN)

local function FlashWhenVulnerable(mo)
	if (mo.flags & MF_SHOOTABLE) then
		if (((leveltime % 16) + 1) < 8)
			mo.colorized = true
			mo.color = SKINCOLOR_SUPERSILVER1
		else
			mo.colorized = false
			mo.color = SKINCOLOR_NONE
		end
		
		if not (S_SoundPlaying(mo, sfx_ptbvul))
			S_StartSoundAtVolume(mo, sfx_ptbvul, 40)
		end
	else
		mo.colorized = false
		mo.color = SKINCOLOR_NONE
	end
end

local function PeppermanWallBonk(mo, obj, line)
	if not (mo.state == S_PEPPERMAN_CHARGE)
	and not (mo.state == S_PEPPERMAN_MINI_RUN)
	and not (mo.state == S_PEPPERMAN_HURTTHROWN)
	and not (mo.state == S_PEPPERMAN_HURT)
	and not (mo.state == S_PEPPERMAN_BOUNCE)
	or not (line)
	or (mo.state == S_PEPPERMAN_BOUNCE)
	and (mo.extravalue1)
		return
	end
	
	//turn instead of wall bonk
	if not (mo.extravalue1)
	and not (mo.minipepperman)
		if (mo.state == S_PEPPERMAN_BOUNCE)
			mo.extravalue1 = 1
		elseif (mo.health < 19)
		and not (mo.health < 11)
		or (mo.health < 9)
			mo.state = S_PEPPERMAN_CHARGETURN
			mo.extravalue1 = 1
			return
		end
	end

	local heightSide = P_PointOnLineSide(mo.x, mo.y, line)
	
	if (heightSide) then
		heightSide = 0
	else
		heightSide = 1
	end


	local heightSector = line.sidenum[heightSide]
	heightSector = sides[$1]
	
	//check backside
	if (heightSector) then
		heightSector = $1.sector
		if (heightSector.ceilingpic == "F_SKY1")
		and (mo.z > heightSector.ceilingheight) then
			return
		end
	end
	
	local climbangle = R_PointToAngle2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)
	if (heightSide) then
		climbangle = $1 + ANGLE_90
	else
		climbangle = $1 - ANGLE_90
	end
	
	//hurt on wall hit
	if not (mo.beenhurt)
		if (mo.state == S_PEPPERMAN_HURTTHROWN)
		or (mo.state == S_PEPPERMAN_HURT)
			PeppermanTrueHurt(mo)
			SpawnBangEffect(mo)
		end
	end
	
	if (mo.state == S_PEPPERMAN_CHARGE)
		PeppermanScreenShake(mo)
		mo.chargelanddust = true
		mo.state = S_PEPPERMAN_WALLBONK
		S_StopSoundByID(mo, sfx_ptpmch)
		S_StartSound(mo, sfx_ptpmcw)
		
		P_InstaThrust(mo, mo.angle - ANGLE_180, 6*FRACUNIT)
		P_SetObjectMomZ(mo, 14*FRACUNIT)
	elseif (mo.state == S_PEPPERMAN_BOUNCE)
		SpawnBangEffect(mo)
		P_SetObjectMomZ(mo, 8*FRACUNIT)
		A_FaceTarget(mo)
		P_InstaThrust(mo, mo.angle, 10*FRACUNIT)
		S_StartSound(mo, sfx_ptpmwb)
	elseif (mo.minipepperman)
		if not (mo.state == S_PEPPERMAN_MINI_RUN) then
			return true
		end
		
		 mo.state = S_PEPPERMAN_MINI_JUMP
		 mo.angle = mo.angle - ANGLE_180
		 P_InstaThrust(mo, climbangle + ANGLE_180, 12*FRACUNIT)
		P_SetObjectMomZ(mo, 20*FRACUNIT)
	else
		S_StartSound(mo, sfx_ptpmwb)
		mo.angle = mo.angle - ANGLE_180
		P_InstaThrust(mo, mo.angle - ANGLE_180, 22*FRACUNIT)
	end
	
	return true
end
addHook("MobjMoveBlocked", PeppermanWallBonk, MT_BOSS_PEPPERMAN)

local function PeppermanHurt(mo, inf, src, dmg)
	if (mo.health == 1) then
		if (mo.minipepperman)
			if not (mo.state == S_PEPPERMAN_MINI_SHRINK) then
				SpawnBangEffect(mo)
				if (inf)
				and (inf.valid) then
					mo.angle = R_PointToAngle2(mo.x, mo.y, inf.x, inf.y)
					P_InstaThrust(inf, mo.angle, 8*FRACUNIT) //knockback to hopefully look better than flying forwards
				end
				P_KillMobj(mo)
				return true
			end
		else
			mo.shrinkhit = true
			mo.shrankbefore = true
		end
	end

	P_SetObjectMomZ(mo, 9*FRACUNIT, true)
	mo.ignoreground = 3 //fixes not getting launched if player attacks at same spot as pepperman
	mo.extravalue1 = 3
	
	if (inf) then
		mo.angle = R_PointToAngle2(mo.x, mo.y, inf.x, inf.y)
	end
	
	local thrustAng = mo.angle - ANGLE_180
	
	if (inf)
	and (inf.valid) then
		thrustAng = R_PointToAngle2(inf.x, inf.y, mo.x, mo.y)
	elseif (src)
	and (src.valid) then
		thrustAng = R_PointToAngle2(src.x, src.y, mo.x, mo.y)
	end

	P_InstaThrust(mo, thrustAng, 148*FRACUNIT)
	
	
	if (mo.health == 11) //blackout punch
		mo.flags = $1 & ~MF_SHOOTABLE
		PTBFinisherTrigger(mo, inf, src)
		return true
	else	//lazy fix for taking away HP
		mo.health = $1 + 1
		S_StartSound(mo, sfx_ptbhur)
	end
end
addHook("MobjDamage", PeppermanHurt, MT_BOSS_PEPPERMAN)

local function PeppermanTurnCheck(mo)
	local xMod =  FixedMul(cos(mo.angle + ANGLE_90), 512*mo.scale)
	local yMod = FixedMul(sin(mo.angle + ANGLE_90), 512*mo.scale)
	local lineX1 = mo.x + xMod 
	local lineY1 = mo.y + yMod
	local lineX2 = mo.x - xMod
	local lineY2 = mo.y - yMod

	if not P_PointOnLineSide(mo.target.x, mo.target.y, lineX1, lineY1, lineX2, lineY2)
		local refX, refY = P_ClosestPointOnLine(mo.target.x, mo.target.y, lineX1, lineY1, lineX2, lineY2)
		
		if (R_PointToDist2(refX, refY, mo.target.x, mo.target.y) > 32*mo.scale)
			return true
		end
	end
end

local function PhaseMultiply(mo, val)
	if (mo.secondphase) then
		return (val * 15) / 10
	else
		return val
	end
end

//workaround for adding the count on the final two hits for second phase
local function PeppermanChargeBonkAddCheck(mo, hp)
	if (mo.state == S_PEPPERMAN_WALLBONK)
	or (mo.state == S_PEPPERMAN_WALLBONKLOOP)
		if (mo.chargelanddust)
		and (P_IsObjectOnGround(mo))
			SpawnLandDustEffect(mo)
			mo.chargelanddust = false
		end
	
		if (mo.secondphase) then
			return true
		elseif (hp > 2) then
			return true
		end
	end
	
	return false
end

local function PeppermanTimer(mo)
	for player in players.iterate() do
		if not (player.exiting) then
			player.realtime = $1 - mo.ptbtimermod
			
			if (player.realtime < 0) then
				player.realtime = 0
			end
		end
	end
end

local function PeppermanThink(mo)

	if (mo.ptbtimermod) then
		PeppermanTimer(mo)
	end

	if not (mo.health) then
		return
	end

	//harsher gravity
	mo.momz = $1 + P_GetMobjGravity(mo)

	if (mo.state == S_PIZZATOWERBOSS_FINISHERDELAY)
		return
	end
	
	//intro override
	if (mo.state >= S_PEPPERMAN_PREINTRO)
	and (mo.state <= S_PEPPERMAN_INTRO_END)
		PeppermanIntroPlayerReact(mo)
		return
	end
	
	//HP reference
	local HP = mo.health - 10
	if (HP <= 0) then
		HP = mo.health
	end
	
	if (mo.state == S_PEPPERMAN_SOURIDLE) then
		//weird method for aura effect
		local aura = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT)
		aura.sprite = SPR_PRAU
		aura.frame = ((leveltime/2) % G)
		aura.tics = 2
	end
	
	if (mo.state == S_PEPPERMAN_CHARGE)
	or (mo.state == S_PEPPERMAN_GROUNDSLAM)
		local hurtbox = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PEPPERMAN_HURTBOX)
		hurtbox.tics = 1
		
		if not (leveltime % 8) then
			PTBAfterimage(mo)
		end
	end
	
	if (mo.state == S_PEPPERMAN_IDLE)
	or (mo.state == S_PEPPERMAN_SOURIDLE)
		mo.extravalue1 = 0
	end
	
	//next to chiseled statue
	if not (mo.state == S_PEPPERMAN_CONTEMPLATE)
	and not (mo.state == S_PEPPERMAN_HURTTHROWN)
	and not (mo.state == S_PEPPERMAN_HURT)
	and (P_IsObjectOnGround(mo))
	and (mo.statue)
	and (mo.statue.valid)
	and not (mo.statue.flags)
	and not (mo.minipepperman)
	and (R_PointToDist2(mo.x, mo.y, mo.statue.x, mo.statue.y) < 180*FRACUNIT) then
		S_StopSound(mo)
		S_StopSoundByID(mo, sfx_ptpmch)
		mo.momx = 0
		mo.momy = 0
		mo.state = S_PEPPERMAN_CONTEMPLATE
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.statue.x, mo.statue.y)
	end
	
	
	//remove invicibility bug and we don't want flashing anyways
	if (PeppermanChargeBonkAddCheck(mo, HP))
	or (mo.state == S_PEPPERMAN_GROUNDSLAMLAND)
	or (mo.state == S_PEPPERMAN_CONTEMPLATE)
	or (mo.state == S_PEPPERMAN_BOUNCE)
	and (mo.extravalue1)
	or (mo.minipepperman)
	and not (mo.state == S_PEPPERMAN_MINI_SHRINK)
	
		if not (mo.flags & MF_SPECIAL)
			if (HP < 9)
			or (mo.secondphase)
				if not (mo.vulncount) then
					mo.vulncount = 0
				end
				
				mo.vulncount = $1 + 1
				
				if (mo.vulncount >= 2)
					mo.vulncount = 0
					if (mo.peppermanknight) then
						PeppermanSpawnExtraObject(mo, MT_PEPPERMAN_KNIGHTSTATUE, mo.angle, true)
						mo.peppermanknight = false
					else
						local target = mo.target
						//fall on self if there's no target
						if not (mo.target) then
							target = mo
						end

						local falling = P_SpawnMobj(target.x, target.y, target.z + 512*FRACUNIT, MT_PEPPERMAN_FALLINGSTATUE)
						
						//double statues
						if (HP < 5)
						and (HP > 2) then
							falling.tracer = target
							falling.spawnextra = true
						end
						
						//spawn knight statue next time
						if (mo.secondphase) then
							mo.peppermanknight = true
						end
					end
				end
			end
		end
		
		//increase count on final second phase anyways
		//add special but not shootable so we know it's been set
		if (HP < 3)
		and (mo.secondphase)
		and (PeppermanChargeBonkAddCheck(mo, HP))
			mo.flags = $1|MF_SPECIAL
		else
			mo.flags = $1|MF_SHOOTABLE|MF_SPECIAL|MF_ENEMY
		end
	else
		//final phase workaround
		if not (mo.state == S_PEPPERMAN_WALLBONK)
		and not (mo.state == S_PEPPERMAN_WALLBONKLOOP)
			mo.flags = $1 & ~MF_SHOOTABLE
			mo.flags = $1 & ~MF_SPECIAL
			mo.flags = $1 & ~MF_ENEMY
		end
	end

	FlashWhenVulnerable(mo)
	
	//flashing
	if (mo.state == S_PEPPERMAN_HURTTHROWN)
	or (mo.state == S_PEPPERMAN_HURT)
	or (mo.state == S_PEPPERMAN_MINI_SHRINK)
		if (((leveltime % 16) + 1) < 8)
			mo.frame = $1|FF_TRANS50
		else
			mo.frame = $1 & ~FF_TRANS50
		end
	end
	
	//mini pepperman interupt
	if (mo.minipepperman) then
		if not (mo.state == S_PEPPERMAN_MINI_SHRINK)
			MiniPeppermanThinker(mo)
		end
		return
	end

	//respawn statue if it disappeared somehow
	if not (mo.statue)
	or not (mo.statue.valid)
		PeppermanSpawnChiselStatue(mo)
	end
	
	if (HP < 9)
		if (mo.artdudetimer) then
			mo.artdudetimer = $1 - 1
		else
			PeppermanSpawnExtraObject(mo, MT_PEPPERMAN_ARTDUDE, mo.angle)
			mo.artdudetimer = 15*TICRATE
		end
	end
	
	if (mo.state == S_PEPPERMAN_CHOOSEATTACK) then
		ClosestLookForPlayer(mo, 0, true)
		if (mo.target) then
			A_FaceTarget(mo)
			if (HP > 2)
			and (HP < 7)
			or (mo.shrankbefore)
				mo.state = S_PEPPERMAN_JUMP
			elseif (HP > 6)
			or (HP < 3)
				mo.state = S_PEPPERMAN_CHARGEWINDUP
			end
		else
			mo.state = S_PEPPERMAN_IDLE
		end
	
	elseif (mo.state ==S_PEPPERMAN_HURTTHROWN)
	or (mo.state == S_PEPPERMAN_HURT) then
		if not (mo.flags2 & MF2_FRET) then
			if (P_IsObjectOnGround(mo))
			and (mo.extravalue1)
				if (mo.state == S_PEPPERMAN_HURTTHROWN)
				and not (mo.ignoreground)
					mo.state = S_PEPPERMAN_HURT
				end
				P_SetObjectMomZ(mo, 8*FRACUNIT, true)
				SpawnLandDustEffect(mo)
				
				mo.extravalue1 = $1 - 1
			end
			
			if (mo.ignoreground) then
				mo.ignoreground = $1 - 1
			end
			
			if not (mo.extravalue1) then
				SpawnLandDustEffect(mo)
				if (mo.health == 10)
				and not (mo.secondphase) then
					PeppermanTriggerSecondPhase(mo)
				end
				
				if (mo.shrinkhit)
					PeppermanDestroyStatue(mo)
					mo.shrinktime = 15*TICRATE
					mo.minipepperman = true
					mo.state = S_PEPPERMAN_MINI_SHRINK
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.shrinkhit = false
					S_StartSound(mo, sfx_ptpmsh)
					S_StartSound(mo, sfx_ptpmsc)
					//lower volume
					S_SetInternalMusicVolume(25)
				else
					mo.state = S_PEPPERMAN_HURTCHECK
					mo.momz = 0
				end
			else
				if (mo.state == S_PEPPERMAN_HURTTHROWN)
					P_InstaThrust(mo, mo.angle - ANGLE_180, 48*FRACUNIT)
				else
					P_InstaThrust(mo, mo.angle - ANGLE_180, 12*FRACUNIT)
				end
			end
		end
		
	elseif (mo.state == S_PEPPERMAN_BOUNCE)
		if (P_IsObjectOnGround(mo))
		and (mo.lastbounce)
		and (leveltime - mo.lastbounce > 15)
			mo.state = S_PEPPERMAN_IDLE
			mo.extravalue1 = 0
		else
			//fall slower to make hitting him easier
			if (mo.momz < -16*FRACUNIT) then
				P_SetObjectMomZ(mo, -16*FRACUNIT)
			end
		end
	
	elseif (mo.state == S_PEPPERMAN_GROUNDSLAM)
		if (P_IsObjectOnGround(mo)) then
			S_StartSound(mo, sfx_ptslam)
			PeppermanScreenShake(mo)
			P_SpawnMobj(mo.x, mo.y, mo.z, MT_PIZZATOWERBOSS_GROUNDPOUNDEFFECT)
			if (HP < 5)
				mo.state = S_PEPPERMAN_GROUNDSLAMLANDTOBOUNCE
			else
				mo.state = S_PEPPERMAN_GROUNDSLAMLAND
			end
		else
			mo.momz = $1 + (P_GetMobjGravity(mo)*PhaseMultiply(mo, 6))
		end
	elseif (mo.state == S_PEPPERMAN_GROUNDSLAMSTART)
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
	end
	
	mo.flags2 = $1 & ~MF2_FRET
	
	if (mo.state == S_PEPPERMAN_WALLBONK)
		return
	end
	
	//separate check for attacks to apply after setting
	if (mo.state == S_PEPPERMAN_CHARGEWINDUP)
		P_InstaThrust(mo, mo.angle-ANGLE_180, 4*mo.scale)
	elseif (mo.state == S_PEPPERMAN_CHARGE)
	
		//charge sound loop
		if not (S_SoundPlaying(mo, sfx_ptpmch))
			S_StartSound(mo, sfx_ptpmch)
		end
	
		//make sure we have someone we're looking for
		if not (mo.target) then
			ClosestLookForPlayer(mo, 0, true)
		end
	
		if (mo.target)
		and (mo.target.valid)
			PTBFaceTowards(mo, mo.target)
		end
		
		//charge turn check
		if (HP <= 8)
		and not (mo.extravalue1)
		and (mo.target)
		and (PeppermanTurnCheck(mo))
			mo.extravalue1 = 1
			mo.state = S_PEPPERMAN_CHARGETURN
		else
			if not (mo.extravalue1) then
				P_InstaThrust(mo, mo.angle, PhaseMultiply(mo, 30)*mo.scale)
			else
				P_InstaThrust(mo, mo.angle, PhaseMultiply(mo, 45)*mo.scale)
			end
		end
		
	elseif (mo.state == S_PEPPERMAN_JUMP)
	or (mo.state == S_PEPPERMAN_JUMPLOOP)
		if not (mo.target) then
			ClosestLookForPlayer(mo, 0, true)
		end
		
		A_FaceTarget(mo)
		
		local thrustSpeed = PhaseMultiply(mo, 28)*mo.scale
		
		if (R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < thrustSpeed) then
			thrustSpeed = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
		end
		
		P_InstaThrust(mo, mo.angle, thrustSpeed)
		
		if (mo.state == S_PEPPERMAN_JUMP) then
			P_SetObjectMomZ(mo, PhaseMultiply(mo, 17)*FRACUNIT, false)
		else
			P_SetObjectMomZ(mo, PhaseMultiply(mo, 4)*FRACUNIT, false)
		end
		
		if (R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < 26*FRACUNIT) then
			mo.state = S_PEPPERMAN_GROUNDSLAMSTART
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
		end
	end
end
addHook("MobjThinker", PeppermanThink, MT_BOSS_PEPPERMAN)
